SystemOrganization addCategory: #'CodeSight-Tests'!
SystemOrganization addCategory: #'CodeSight-Tracer'!
SystemOrganization addCategory: #'CodeSight-TraceBrowser'!
SystemOrganization addCategory: #'CodeSight-TestTracer'!
SystemOrganization addCategory: #CodeSight!

OBBrowser subclass: #CSTraceBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSTraceBrowser class methodsFor: 'configuration' stamp: 'mp 2/8/2009 18:12'!
defaultMetaNode
	
	| start nextCalls |
	start := OBMetaNode named: 'Traces'.
	nextCalls := OBMetaNode named: 'Next Calls'.
	
	start
		childAt: #traces put: start;
		childAt: #nextCalls put: nextCalls.
	
	nextCalls
		childAt: #nextCalls put: nextCalls.
	
	^ start! !

!CSTraceBrowser class methodsFor: 'configuration' stamp: 'mp 2/8/2009 17:23'!
defaultRootNode
	
	^ CSTraceStartNode new! !

!CSTraceBrowser class methodsFor: 'configuration' stamp: 'mp 2/8/2009 18:47'!
title

	^ 'Trace Browser'! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/30/2009 15:07'!
called: aCompiledMethod inDepth: aNumber 
	| statistic |
	aCompiledMethod coveringTestMethods add: self.
	statistic := self coveredMethodsStatistics 
		at: aCompiledMethod
		ifAbsentPut: [ CSTestStatistic new ].
	statistic addCallInDepth: aNumber! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/30/2009 16:30'!
coveredMethodsStatistics
	^ self properties 
		at: #codeSightStatistics
		ifAbsentPut: [ IdentityDictionary new ]! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/30/2009 16:30'!
coveringTestMethods
	^ self properties at: #codeSightCovering ifAbsentPut: [ IdentitySet new ]! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/24/2009 16:01'!
hasCoveringTestMethods
	^ self coveringTestMethods isEmpty not.! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/30/2009 16:29'!
removeCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self coveringTestMethods remove: aTestCaseMethod.! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/30/2009 11:16'!
resetCoveredMethodsStatistics
	self coveredMethodsStatistics keysDo: [ :coveredMethod | coveredMethod removeCoveringTestMethod: self ].
	self properties 
		removeKey: #codeSightStatistics
		ifAbsent: [  ]! !

!CompiledMethod methodsFor: '*codesight' stamp: 'bs 4/30/2009 16:33'!
statisticsForCoveredMethod: aCompiledMethod 
	
	^ self coveredMethodsStatistics at: aCompiledMethod! !

OBEnhancementMetagraphBuilder subclass: #CSMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 23:41'!
createMethodMetaNode
	| methodMetaNode testMetaNode |
	testMetaNode := OBEnhancementMetaNode named: #CoveringTestCases.
	methodMetaNode := OBEnhancementMetaNode named: #Method.
	methodMetaNode childAt: #coveringTestMethods put: testMetaNode.
	^ methodMetaNode! !

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 09:57'!
methodMetaNode
   ^(self metaNodes
		at: #Method
		ifAbsentPut: [OBEnhancementMetaNode named: #Method])! !

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 10:00'!
populateMethodNode
	| testMetaNode |
	super populateMethodNode.
	testMetaNode := OBEnhancementMetaNode named: #CoveringTestCases.
	self methodMetaNode
		childAt: #coveringTestMethods put: testMetaNode.
! !

TestCase subclass: #CSExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExampleTest methodsFor: 'as yet unclassified' stamp: 'mab 3/25/2009 16:15'!
testFailing
	self assert: false.
	! !

!CSExampleTest methodsFor: 'as yet unclassified' stamp: 'mab 3/23/2009 17:50'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := CSExamplePerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.
	! !

TestCase subclass: #CSTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTest methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 10:23'!
testRetrievingTestsForMethod
	| aTestRunner aSuite |
	aTestRunner := CSTestRunner new.
	aTestRunner classesToBeTraced: { CSExamplePerson }.
	aSuite := CSExampleTest suite.
	aTestRunner runSuite: aSuite.
	self assert: ((CSExamplePerson>>#firstname:) coveringTestMethods includes: CSExampleTest >> #testFirstnameAccessors)..! !

!CSTest methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 10:23'!
testRetrievingTestsForQuickReturnMethod
	| aTestRunner aSuite |
	aTestRunner := CSTestRunner new.
	aTestRunner classesToBeTraced: { CSExamplePerson }.
	aSuite := CSExampleTest suite.
	aTestRunner runSuite: aSuite.
	self assert: ((CSExamplePerson>>#firstname) coveringTestMethods includes: CSExampleTest >> #testFirstnameAccessors).! !

TestCase subclass: #CSTraceTest
	instanceVariableNames: 'tracer identifier example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTraceTest methodsFor: 'private' stamp: 'mp 2/11/2009 11:37'!
checkCallEntry: aCallEntry methodClass: aClass methodSelector: aSymbol receiver: receiver arguments: arguments depth: aDepthCollection

	self assert: aCallEntry isCall.
	self assert: aCallEntry methodClass = aClass.
	self assert: aCallEntry methodSelector = aSymbol.
	self assert: aCallEntry receiver = receiver.
	self assert: aCallEntry arguments = arguments.
	self assert: aCallEntry depth size = aDepthCollection size.
	self assert: (aCallEntry depth hasEqualElements: aDepthCollection).! !

!CSTraceTest methodsFor: 'private' stamp: 'mp 2/11/2009 13:38'!
checkMethodWasNotTraced: aMethod

	self deny: (aMethod properties includesKey: self identifier).! !

!CSTraceTest methodsFor: 'private' stamp: 'mp 2/11/2009 13:40'!
checkMethodsFromClassWereNotTraced: aClass except: aSelectorCollection

	aClass methodDict do: [:each | 
		(aSelectorCollection includes: each selector)
			ifFalse: [self checkMethodWasNotTraced: each]].! !

!CSTraceTest methodsFor: 'private' stamp: 'mp 2/13/2009 14:11'!
checkReturnEntry: aReturnEntry methodClass: aClass methodSelector: aSelector depth: aDepthCollection

	self assert: aReturnEntry isReturn.
	self assert: aReturnEntry methodClass = aClass.
	self assert: aReturnEntry methodSelector = aSelector.
	self assert: aReturnEntry depth size = aDepthCollection size.
	self assert: (aReturnEntry depth hasEqualElements: aDepthCollection).! !

!CSTraceTest methodsFor: 'private' stamp: 'mp 2/13/2009 14:10'!
checkReturnEntry: aReturnEntry methodClass: aClass methodSelector: aSelector depth: aDepthCollection returnValue: returnValue

	self checkReturnEntry: aReturnEntry 
		methodClass: aClass 
		methodSelector: aSelector 
		depth: aDepthCollection.
	self assert: aReturnEntry returnValue = returnValue.! !

!CSTraceTest methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:44'!
example
	"Answer the value of example"

	^ example! !

!CSTraceTest methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:44'!
example: anObject
	"Set the value of example"

	example := anObject! !

!CSTraceTest methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:37'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSTraceTest methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:37'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSTraceTest methodsFor: 'running' stamp: 'mp 2/10/2009 12:42'!
setUp
	
	super setUp.
	self identifier: #CSUnitTestTrace.
	self tracer: (CSTracer identifier: self identifier).
	self example: CSExampleTrace new.! !

!CSTraceTest methodsFor: 'running' stamp: 'mp 2/13/2009 11:25'!
tearDown
	super tearDown.
	
	CSTraceRegistry cleanAnnotationsFor: self identifier.! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/10/2009 12:42'!
testAutomaticIdentifier

	| id idDate now |
	self tracer: CSTracer new.
	id := self tracer identifier.
	self tracer trace: [self example doNothing].
	
	self deny: (CSTraceRegistry current traces includesKey: self identifier).
	self assert: (CSTraceRegistry current traces includesKey: id).
	
	CSTraceRegistry current traces removeKey: id.
	self deny: (CSTraceRegistry current traces includesKey: id).
	
	idDate := DateAndTime fromString: id.
	now := DateAndTime now.
	self assert: idDate year =  now year.
	self assert: idDate month = now month.
	self assert: idDate day = now day.! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:20'!
testBlockTrace

	| result entries |
	result := self example loop.
	self example reset.
	self assert: result = (self tracer trace: [self example loop]).
	self assert: result = 9.
	
	entries := (Integer>>#timesRepeat:) properties at: self identifier.
	self assert: entries size = 4.
	
	self checkCallEntry: entries first
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1).

	self checkCallEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1 2).
		
	self checkCallEntry: entries third
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1 3).
		
	self checkReturnEntry: entries fourth
		methodClass: CSExampleTrace
		methodSelector: #loop
		depth:  #(1 1)
		returnValue: 3.
		
	entries := (CSExampleTrace>>#loop) properties at: self identifier.
	self assert: entries size = 9.

	self checkCallEntry: entries first
		methodClass: Integer
		methodSelector: #timesRepeat:
		receiver:  nil
		arguments:  nil
		depth: #(1 1).
	
	"3x Block Calls"
	self checkCallEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 1).
		
	self checkReturnEntry: entries third
		methodClass: Integer 
		methodSelector: #timesRepeat:
		depth: #(1 1 1)
		returnValue: 1.
		
	self checkCallEntry: entries fourth
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 2 1).
		
	self checkReturnEntry: entries fifth
		methodClass: Integer 
		methodSelector: #timesRepeat:
		depth: #(1 1 2)
		returnValue: 2.		

	self checkCallEntry: entries sixth
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 3 1).
		
	self checkReturnEntry: entries seventh
		methodClass: Integer 
		methodSelector: #timesRepeat:		
		depth: #(1 1 3)
		returnValue: 3.	! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 18:29'!
testClassMethodTrace

	| registeredTrace entries |
	self assert: (self tracer trace: [CSExampleTrace traceRegistry traces includesKey: self identifier]).
	
	registeredTrace := CSTraceRegistry current traces at: self identifier.
	self assert: registeredTrace startEntries size = 2.
	
	self checkCallEntry: registeredTrace startEntries first
		methodClass: CSExampleTrace class
		methodSelector: #traceRegistry 
		receiver: nil 
		arguments: nil 
		depth: #(1).
	
	entries := (CSExampleTrace class>>#traceRegistry) properties at: self identifier.
	self assert: entries size = 2.
	self checkCallEntry: entries first
		methodClass: CSTraceRegistry class
		methodSelector: #current 
		receiver: nil 
		arguments: nil 
		depth: #(1 1).
		
	self checkReturnEntry: entries second 
		methodClass: CSTraceTest
		methodSelector: #testClassMethodTrace
		depth: #(1).
	self deny: entries second returnValue == CSTraceRegistry current.
	self assert: (entries second returnValue isKindOf: CSTraceRegistry).
	self assert: entries second returnValue traces size = CSTraceRegistry current traces size.! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:33'!
testComplexMethodTrace

	| result entries |
	result := self example complexMethodCalls.
	self example reset.
	self assert: result = (self tracer trace: [self example complexMethodCalls]).
	self assert: result = 220.
	
	"Start entries"
	self checkCallEntry: (CSTraceRegistry current traces at: self identifier) startEntries first
		methodClass: CSExampleTrace
		methodSelector: #complexMethodCalls
		receiver: nil
		arguments: nil  
		depth: #(1).
		
	"Return value"
	self checkReturnEntry: (CSTraceRegistry current traces at: self identifier) returnValue
		methodClass: nil 
		methodSelector: nil	
		depth: #()
		returnValue: 220.
	
	"Follow the complex path"
	entries := (CSExampleTrace>>#complexMethodCalls) properties at: self identifier.
	self assert: entries size = 5.
	
	self checkCallEntry: entries first
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1).
	
	self checkCallEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 2).	
	
	self checkCallEntry: entries third
		methodClass: CSExampleTrace
		methodSelector: #squareCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 3).	
			
	self checkCallEntry: entries fourth
		methodClass: CSExampleTrace
		methodSelector: #conditional
		receiver:  nil
		arguments:  nil
		depth: #(1 4).
	
	self checkReturnEntry: entries fifth 
		methodClass: CSTraceTest
		methodSelector: #testComplexMethodTrace	
		depth: #(1) 
		returnValue: 220.
	
	entries := (CSExampleTrace>>#loop) properties at: self identifier.
	self assert: entries size = 9.
	
	self checkCallEntry: entries first
		methodClass: Integer
		methodSelector: #timesRepeat:
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1).
	
	"3x Block Calls"
	self checkCallEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 1 1).
		
	self checkReturnEntry: entries third
		methodClass: Integer 
		methodSelector: #timesRepeat:	
		depth: #(1 1 1 1)
		returnValue: 1.
		
	self checkCallEntry: entries fourth
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 2 1).
		
	self checkReturnEntry: entries fifth
		methodClass: Integer 
		methodSelector: #timesRepeat:		
		depth: #(1 1 1 2)
		returnValue: 2.		

	self checkCallEntry: entries sixth
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 3 1).
		
	self checkReturnEntry: entries seventh
		methodClass: Integer 
		methodSelector: #timesRepeat:
		depth: #(1 1 1 3)
		returnValue: 3.		
			
	self checkCallEntry: entries eighth
		methodClass: CSExampleTrace
		methodSelector: #squareCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 1 2).	
			
	self checkReturnEntry: entries ninth
		methodClass: CSExampleTrace
		methodSelector: #complexMethodCalls
		depth:  #(1 1)
		returnValue: 9.
	
	entries := (Integer>>#timesRepeat:) properties at: self identifier.
	self assert: entries size = 4.	
	
	self checkCallEntry: entries first
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 1).

	self checkCallEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 2).
		
	self checkCallEntry: entries third
		methodClass: CSExampleTrace
		methodSelector: #loop
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 3).
		
	self checkReturnEntry: entries fourth
		methodClass: CSExampleTrace
		methodSelector: #loop
		depth:  #(1 1 1)
		returnValue: 3.
	
	entries := (CSExampleTrace >>#incrementCounter) properties at: self identifier.
	self assert: entries size = 10.		

	self checkCallEntry: (entries at: 1)
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 1 1 1).
		
	self checkReturnEntry: (entries at: 2)
		methodClass: CSExampleTrace
		methodSelector: #loop
		depth:  #(1 1 1 1 1)
		returnValue: 1.			
	
	self checkCallEntry: (entries at: 3)
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 2 1 1).
		
	self checkReturnEntry: (entries at: 4)
		methodClass: CSExampleTrace
		methodSelector: #loop
		depth:  #(1 1 1 2 1)
		returnValue: 2.
		
	self checkCallEntry: (entries at: 5)
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 1 1 3 1 1).
		
	self checkReturnEntry: (entries at: 6)
		methodClass: CSExampleTrace
		methodSelector: #loop		
		depth:  #(1 1 1 3 1)
		returnValue: 3.
		
	self checkCallEntry: (entries at: 7)
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 2 1).
		
	self checkReturnEntry: (entries at: 8)
		methodClass: CSExampleTrace
		methodSelector: #complexMethodCalls
		depth:  #(1 2)
		returnValue: 10.
		
	self checkCallEntry: (entries at: 9)
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 4 1 1).
		
	self checkReturnEntry: (entries at: 10)
		methodClass: CSExampleTrace
		methodSelector: #conditional
		depth:  #(1 4 1)
		returnValue: 101.				
	
	entries := (CSExampleTrace >>#counter:) properties at: self identifier.
	self assert: entries size = 7.
	entries do: [:each | self assert: each isReturn].
	
	entries := (CSExampleTrace >>#squareCounter) properties at: self identifier.
	self assert: entries size = 6.	
	
	self checkCallEntry: entries first
		methodClass: Number
		methodSelector: #squared
		receiver:  nil
		arguments:  nil
		depth: #(1 1 2 1).

	self checkCallEntry: entries second
		methodClass: CSExampleTrace 
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 1 2 2).		

	self checkReturnEntry: entries third
		methodClass: CSExampleTrace
		methodSelector: #loop	
		depth:  #(1 1 2)
		returnValue: 9.	
			
	self checkCallEntry: entries fourth
		methodClass: Number
		methodSelector: #squared
		receiver:  nil
		arguments:  nil
		depth: #(1 3 1).

	self checkCallEntry: entries fifth
		methodClass: CSExampleTrace 
		methodSelector: #counter:
		receiver:  nil
		arguments:  nil
		depth: #(1 3 2).		

	self checkReturnEntry: entries sixth
		methodClass: CSExampleTrace
		methodSelector: #complexMethodCalls
		depth:  #(1 3)
		returnValue: 100.				
	
	entries := (Number >>#squared) properties at: self identifier.
	self assert: entries size = 2.

	self checkReturnEntry: entries first
		methodClass: CSExampleTrace
		methodSelector: #squareCounter	
		depth:  #(1 1 2 1)
		returnValue: 9.	
			
	self checkReturnEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #squareCounter	
		depth:  #(1 3 1)
		returnValue: 100.			
	
	entries := (CSExampleTrace >>#conditional) properties at: self identifier.
	self assert: entries size = 2.

	self checkCallEntry: entries first
		methodClass: CSExampleTrace 
		methodSelector: #incrementCounter
		receiver:  nil
		arguments:  nil
		depth: #(1 4 1).
	
	self checkReturnEntry: entries second
		methodClass: CSExampleTrace
		methodSelector: #complexMethodCalls
		depth:  #(1 4)
		returnValue: 101.		
			
	"Check methods which should not be part of the trace"
	self checkMethodsFromClassWereNotTraced: CSExampleTrace  except: #(complexMethodCalls conditional incrementCounter loop squareCounter counter:)! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:47'!
testDoNothingMethodTrace

	| registeredTrace |
	self tracer trace: [self example doNothing].
	
	self assert: (CSTraceRegistry current traces includesKey: self identifier).
	registeredTrace := CSTraceRegistry current traces at: self identifier.
	self assert: (registeredTrace identifier == self identifier).
	
	self assert: registeredTrace startEntries isEmpty.
	self checkReturnEntry: registeredTrace returnValue 
		methodClass: nil
		methodSelector: nil	
		depth: #().
	self assert: registeredTrace returnValue returnValue counter = 0.
	
	self checkMethodWasNotTraced: CSExampleTrace>>#doNothing.
	self checkMethodWasNotTraced: CSTraceTest>>#example.! !

!CSTraceTest methodsFor: 'ToDoTests' stamp: 'mp 2/9/2009 11:30'!
testEventsTrace! !

!CSTraceTest methodsFor: 'ToDoTests' stamp: 'mp 2/13/2009 11:30'!
testExceptionTrace

	self assert: ((self tracer trace: [self example throwError]) = 1).
	
	! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 18:21'!
testMultipleMethodsTrace

	| result entries |
	result := self example incrementCounter + self example incrementCounter.
	self example reset.
	self assert: result = (self tracer trace: [self example incrementCounter + self example incrementCounter]).
	
	self assert: ((CSExampleTrace>>#incrementCounter) properties includesKey: self identifier).
	entries := (CSExampleTrace>>#incrementCounter) properties at: self identifier.
	self assert: entries size = 4.
	
	self checkCallEntry: entries first 
		methodClass: CSExampleTrace 
		methodSelector: #counter: 
		receiver: nil 
		arguments: nil 
		depth: #(1 1).
	
	self checkReturnEntry: entries second
		methodClass: CSTraceTest
		methodSelector: #testMultipleMethodsTrace
		depth: #(1)
		returnValue: 1.

	self checkCallEntry: entries third 
		methodClass: CSExampleTrace 
		methodSelector: #counter: 
		receiver: nil 
		arguments: nil 
		depth: #(2 1).
	
	self checkReturnEntry: entries fourth
		methodClass: CSTraceTest
		methodSelector: #testMultipleMethodsTrace
		depth: #(2)
		returnValue: 2.		
	
	self assert: ((CSExampleTrace>>#counter:) properties includesKey: self identifier).
	entries := (CSExampleTrace>>#counter:) properties at: self identifier.
	self assert: entries size = 2.

	self checkReturnEntry: entries first 
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter	
		depth: #(1 1).
	self assert: entries first returnValue counter = 1. 

	self checkReturnEntry: entries second 
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		depth: #(2 1).
	self assert: entries second returnValue counter = 2.
			
	self checkMethodsFromClassWereNotTraced: CSExampleTrace 
		except: #(counter: incrementCounter).
	self checkMethodWasNotTraced: Number>>#+.
	self checkMethodWasNotTraced: Integer>>#+.
	self checkMethodWasNotTraced: SmallInteger>>#+.! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:37'!
testMultipleStartEntries

	| registeredTrace |
	self tracer trace: [self example incrementCounter + self example incrementCounter].
	
	self assert: (CSTraceRegistry current traces includesKey: self identifier).
	registeredTrace := CSTraceRegistry current traces at: self identifier.
	self assert: (registeredTrace identifier == self identifier).
	self assert: registeredTrace startEntries size = 2.
	
	self checkCallEntry: registeredTrace startEntries first
		methodClass: CSExampleTrace 
		methodSelector: #incrementCounter 
		receiver: nil 
		arguments: nil 
		depth: #(1).	
	
	self checkCallEntry: registeredTrace startEntries second
		methodClass: CSExampleTrace 
		methodSelector: #incrementCounter 
		receiver: nil 
		arguments: nil 
		depth: #(2).	
	
	self checkReturnEntry: registeredTrace returnValue 
		methodClass: nil
		methodSelector: nil		
		depth: #() 
		returnValue: 3.! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/11/2009 18:29'!
testObserverTrace

	| entries |
	self assert: ((self tracer trace: [self example observerCounter]) = 3).
	
	entries := (Object>>#changed) properties at: self identifier.
	self assert: entries size = 2.
	self checkCallEntry: entries first 
		methodClass: Object
		methodSelector: #changed:
		receiver: nil
		arguments: nil
		depth: #(1 2 1).
		
	self assert: ((CSExampleTrace>>#update:) properties includesKey: self identifier).
	entries := (CSExampleTrace>>#update:) properties at: self identifier.
	self assert: entries size = 2.
	self checkCallEntry: entries first 
		methodClass: CSExampleTrace 
		methodSelector: #incrementCounter
		receiver: nil
		arguments: nil
		depth: #(1 2 1 2 1 1 1).	
	
	
	! !

!CSTraceTest methodsFor: 'ToDoTests' stamp: 'mp 2/9/2009 11:29'!
testPrimitiveMethodTrace! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/11/2009 18:50'!
testPrintTrace

	| stream |
	self assert: ((self tracer trace: [self example loop]) = 9).
	
	stream := ReadWriteStream with: String new.  
	CSTraceRegistry current printTrace: self identifier on: stream.
	self assert: stream contents =  '
#CSUnitTestTrace
 CSExampleTrace>>#loop
  Integer>>#timesRepeat:
   CSExampleTrace>>#loop
    CSExampleTrace>>#incrementCounter
     CSExampleTrace>>#counter:
     ^a CSExampleTrace
    ^1
   ^1
   CSExampleTrace>>#loop
    CSExampleTrace>>#incrementCounter
     CSExampleTrace>>#counter:
     ^a CSExampleTrace
    ^2
   ^2
   CSExampleTrace>>#loop
    CSExampleTrace>>#incrementCounter
     CSExampleTrace>>#counter:
     ^a CSExampleTrace
    ^3
   ^3
  ^3
  CSExampleTrace>>#squareCounter
   Number>>#squared
   ^9
   CSExampleTrace>>#counter:
   ^a CSExampleTrace
  ^9
 ^9
^9'.
	! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:39'!
testRecursiveTrace

	| entries |
	self assert: ((self tracer trace: [3 factorial]) = 6).
	
	entries := (Integer>>#factorial) properties at: self identifier.
	self assert: entries size = 7.

	self checkCallEntry: entries first 
		methodClass: Integer
		methodSelector: #factorial
		receiver: nil
		arguments: nil
		depth: #(1 1).
	self checkCallEntry: entries second 
		methodClass: Integer
		methodSelector: #factorial
		receiver: nil
		arguments: nil
		depth: #(1 1 1).
	self checkCallEntry: entries third 
		methodClass: Integer
		methodSelector: #factorial
		receiver: nil
		arguments: nil
		depth: #(1 1 1 1).
	self checkReturnEntry: entries fourth 
		methodClass: Integer
		methodSelector: #factorial		
		depth:  #(1 1 1 1)
		returnValue: 1.
	self checkReturnEntry: entries fifth 
		methodClass: Integer
		methodSelector: #factorial		
		depth:  #(1 1 1)
		returnValue: 1.
	self checkReturnEntry: entries sixth 
		methodClass: Integer
		methodSelector: #factorial		
		depth:  #(1 1)
		returnValue: 2.
	self checkReturnEntry: entries seventh 
		methodClass: CSTraceTest
		methodSelector: #testRecursiveTrace		
		depth:  #(1)
		returnValue: 6.						! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 11:26'!
testRemoveTrace

	self assert: ((self tracer trace: [self example complexMethodCalls]) = 220).

	CSExampleTrace methodDict do: [:each | 
		(#(doNothing initialize observerCounter reset update: counter throwError) includes: each selector)
			ifFalse: [self assert: (each properties includesKey: self identifier)]].	

	CSTraceRegistry current removeTrace: self identifier.

	self checkMethodsFromClassWereNotTraced: CSExampleTrace  except: #().
	self checkMethodWasNotTraced: (Integer>>#timesRepeat:).
	self checkMethodWasNotTraced: (Number>>#squared).! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:49'!
testSimpleMethodTrace

	| result entries |
	result := self example incrementCounter.
	self example reset.
	self assert: result = (self tracer trace: [self example incrementCounter]).

	self assert: ((CSExampleTrace>>#incrementCounter) properties includesKey: self identifier).
	entries := (CSExampleTrace>>#incrementCounter) properties at: self identifier.
	self assert: entries size = 2.
	self checkCallEntry: entries first 
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver: nil
		arguments: nil
		depth: #(1 1).
	
	self checkReturnEntry: entries second 
		methodClass: CSTraceTest
		methodSelector: #testSimpleMethodTrace		
		depth: #(1) 
		returnValue: 1.
	
	self assert: ((CSExampleTrace>>#counter:) properties includesKey: self identifier).
	entries := (CSExampleTrace>>#counter:) properties at: self identifier.
	self assert: entries size = 1.

	self checkReturnEntry: entries first 
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter		
		depth: #(1 1).
	self assert: (entries first returnValue isKindOf: CSExampleTrace).
	self assert: entries first returnValue counter = 1.
	
	self checkMethodsFromClassWereNotTraced: CSExampleTrace
		except: #(counter: incrementCounter).
	self checkMethodWasNotTraced: CSTraceTest>>#example.! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:50'!
testSimpleStartEntry

	| registeredTrace now |
	self tracer trace: [self example incrementCounter].
	
	self assert: (CSTraceRegistry current traces includesKey: self identifier).
	registeredTrace := CSTraceRegistry current traces at: self identifier.
	self assert: (registeredTrace identifier == self identifier).
	
	now := DateAndTime now.
	self assert: registeredTrace timestamp year =  now year.
	self assert: registeredTrace timestamp month = now month.
	self assert: registeredTrace timestamp day = now day.
	
	self assert: registeredTrace startEntries size = 1.
	
	self checkCallEntry: registeredTrace startEntries first
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver: nil
		arguments: nil
		depth: #(1).
	
	self checkReturnEntry: registeredTrace returnValue 
		methodClass: nil
		methodSelector: nil
		depth: #().
	self assert: registeredTrace returnValue returnValue = 1.	! !

!CSTraceTest methodsFor: 'testing' stamp: 'mp 2/13/2009 14:42'!
testSuperAndInheritedCalls

	| traceTest entries |
	traceTest := CSSubExampleTrace new.
	self assert: ((self tracer trace: [traceTest incrementCounter]) = 2).
	
	entries := (CSSubExampleTrace>>#incrementCounter) properties at: self identifier.
	self assert: entries size = 3.
	self checkCallEntry: entries first 
		methodClass: CSExampleTrace
		methodSelector: #incrementCounter
		receiver: nil
		arguments: nil
		depth: #(1 1).

	self checkCallEntry: entries second 
		methodClass: CSExampleTrace
		methodSelector: #counter:
		receiver: nil
		arguments: nil
		depth: #(1 2).	
			
	self checkReturnEntry: entries third
		methodClass: CSTraceTest
		methodSelector: #testSuperAndInheritedCalls
		depth:  #(1)
		returnValue: 2.! !

!CSTraceTest methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:37'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!CSTraceTest methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:37'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

TestRunner subclass: #CSTestRunner
	instanceVariableNames: 'traceAspect classesToBeTraced'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

CSTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

CSTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 15:28'!
initialize
	"CSTestRunner initialize"
	self registerInWorldMenu; registerInToolsFlap.! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/22/2009 15:14'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTestRunner build 'CodeSight Test Runner' 'A production scale test-runner for XP Forums.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:33'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'CodeSight Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 11:16'!
basicSetUpSuite: aTestSuite 
	aTestSuite tests do: [ :aTestCase | (aTestCase class >> aTestCase selector) resetCoveredMethodsStatistics ].
	traceAspect := CSTestTraceAspect forClasses: self classesToBeTraced.
	traceAspect install.
	super basicSetUpSuite: aTestSuite! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/24/2009 17:59'!
basicTearDownSuite: aTestSuite
	super basicTearDownSuite: aTestSuite.
	traceAspect uninstall.
	! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 11:55'!
classesToBeTraced
	^ classesToBeTraced ifNil: [CSTraceChooser allClasses reject: [:aClass |
			aClass inheritsFrom: TestCase]] ! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/24/2009 14:58'!
classesToBeTraced: classCollection
	classesToBeTraced := classCollection.! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 12:09'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self debugTest: each ].! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 12:09'!
debugTest: aTestCase
	traceAspect testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	aTestCase debug.! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:33'!
label
	^ 'CodeSight Test Runner'! !

!CSTestRunner methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 11:34'!
runTest: aTestCase
	traceAspect testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	super runTest: aTestCase.! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:27'!
compileWithSelfRemovingBreakpoint: aSymbol in: aClass 
	"Compile and return a new method containing a break statement"

	| source node method |
	source := self sourceWithSelfRemovingBreakpointFor: aSymbol in: aClass.
	node := aClass compilerClass new
		compile: source
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	node isNil ifTrue: [^nil].
	"dunno what the arguments mean..."
	method := node generate.
	^method! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:26'!
installSelfRemovingBreakpointInClass: aClass selector: aSymbol 
	"Install a new method containing a breakpoint.
	The receiver will remember this for unstalling it later"

	| breakMethod |
	breakMethod _ self compileWithSelfRemovingBreakpoint: aSymbol in: aClass.
	breakMethod isNil
		ifTrue: [^ nil].
	self installed at: breakMethod put: aClass >> aSymbol. "old method"
	aClass basicAddSelector: aSymbol withMethod: breakMethod.! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:28'!
sourceWithSelfRemovingBreakpointFor: aSymbol in: aClass 
	"Compose new source containing a break statement (currently it will be the first,
	later we want to insert it in any place)"

	| oldSource methodNode breakOnlyMethodNode sendBreakMessageNode |
	oldSource := aClass sourceCodeAt: aSymbol.
	methodNode := aClass compilerClass new
		compile: oldSource
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	breakOnlyMethodNode := aClass compilerClass new
		compile: 'temporaryMethodSelectorForBreakpoint
self debugAndUninstallBreakpointBefore.
^self'
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	sendBreakMessageNode := breakOnlyMethodNode block statements first.
	methodNode block statements addFirst: sendBreakMessageNode.
	^methodNode printString
	! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/15/2009 23:08'!
unInstallInClass: aClass selector: aSymbol
	self unInstall: (aClass compiledMethodAt: aSymbol)! !

!OBMorphicIcons methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:44'!
csAccept

	^ MenuIcons csAcceptIcon! !

Object subclass: #CSCoveringTests
	instanceVariableNames: 'list listIndex browsers browserCreationAspect selectedMethodName selectedMethodClass'
	classVariableNames: 'Packages'
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSCoveringTests class methodsFor: 'as yet unclassified' stamp: 'mab 4/3/2009 15:32'!
build
	^ ToolBuilder build: self new! !

!CSCoveringTests class methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 18:25'!
initialize
	"CSCoveringTests initialize"
	self registerInToolsFlap! !

!CSCoveringTests class methodsFor: 'as yet unclassified' stamp: 'mab 4/3/2009 15:32'!
open
	^ ToolBuilder open: self new! !

!CSCoveringTests class methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 18:24'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSCoveringTests
							build 
							'Covering Tests' 'Lists the tests covering your currently selected method' )
			forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 13:24'!
browserChangedSelection: announcement
	| node |
	
	self selectedMethodClass: nil.
	self selectedMethodName: nil.
	
	node := announcement node.
	(node isNil not and: [ node isMethodNode]) ifTrue: [
		self selectedMethodClass: (node theClass).
		self selectedMethodName: (node selector)].
	
	self recomputeList.
	self changed: #list.! !

!CSCoveringTests methodsFor: 'accessing' stamp: 'mab 4/7/2009 19:05'!
browserCreationAspect
	^ browserCreationAspect! !

!CSCoveringTests methodsFor: 'accessing' stamp: 'mab 4/7/2009 19:05'!
browserCreationAspect: anAspect
	browserCreationAspect := anAspect! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 17:35'!
browsers
	^ browsers ifNil: [ browsers := Set new ] ! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 19:03'!
browsers: aCollection
	browsers := aCollection! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/8/2009 18:22'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec 
		model: self;
		label: 'Tests';
		children: OrderedCollection new;
		closeAction: #close.
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #list;
		getIndex: #listIndex;
		setIndex: #listIndex:;
		frame: (0@0corner: 1@0.8).
	windowSpec children add: listSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec
		model: self;
		label: 'Debug';
		action: #debug;
		frame: (0@0.8 corner: 1@1).
	windowSpec children add: buttonSpec.

	^builder build: windowSpec! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 19:06'!
close
	self unsubscribeFromBrowsers.
	self browserCreationAspect uninstall.! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2009 18:18'!
debug
	| testMethod testClass testSelector testSuite |
	self listIndex > 0 ifTrue: [
		testMethod := self method coveringTestMethods asOrderedCollection at: self listIndex.
		testClass := testMethod methodClass.
		testSelector := testMethod selector.
		testSuite := testClass suiteWithSelectorsMatching: testSelector.
		[
		BreakpointManager installSelfRemovingBreakpointInClass: (self selectedMethodClass) selector: (self selectedMethodName).
		[ testSuite run ] ensure: [ 
			BreakpointManager unInstallInClass: (self selectedMethodClass) selector: (self selectedMethodName). ].
		] forkAt: Processor activePriority.
	]! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 19:06'!
finalize
	self unsubscribeFromBrowsers.
	self browserCreationAspect uninstall.! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 19:05'!
initialize
	OBBrowser allSubInstancesDo: [ :browser | self registerBrowser: browser ].
	self browserCreationAspect: (CSBrowserAspect for: self).
	self browserCreationAspect install.! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/3/2009 15:37'!
list
	^ list ifNil: [ self recomputeList ]! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/8/2009 18:21'!
listIndex
	^ listIndex ifNil: [ listIndex := 0 ]! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/8/2009 18:23'!
listIndex: anObject
	listIndex := anObject.
	self changed: #listIndex! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'bs 4/15/2009 23:31'!
method
	(selectedMethodClass isNil not and: [selectedMethodName isNil not]) ifTrue: [
		^ selectedMethodClass compiledMethodAt: selectedMethodName].
	^ nil.! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 11:28'!
recomputeList
	|statistics|
	list := self method 
		ifNil: [OrderedCollection new ]
		ifNotNil: [self method coveringTestMethods asOrderedCollection collect: [:testMethod| 
			statistics := testMethod statisticsForCoveredMethod: self method.
			statistics asString, ' ', testMethod methodClass name, '>>#', testMethod selector] ].
	listIndex := nil.
	^ list! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2009 18:09'!
registerBrowser: browser
	self browsers add: browser.
	browser announcer observe: OBSelectionChanged send: #browserChangedSelection: to: self.! !

!CSCoveringTests methodsFor: 'accessing' stamp: 'bs 4/15/2009 23:23'!
selectedMethodClass
	^selectedMethodClass! !

!CSCoveringTests methodsFor: 'accessing' stamp: 'bs 4/15/2009 23:23'!
selectedMethodClass: aClass
	selectedMethodClass := aClass! !

!CSCoveringTests methodsFor: 'accessing' stamp: 'bs 4/15/2009 23:23'!
selectedMethodName
	^selectedMethodName! !

!CSCoveringTests methodsFor: 'accessing' stamp: 'bs 4/15/2009 23:23'!
selectedMethodName: aSymbol
	selectedMethodName := aSymbol! !

!CSCoveringTests methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 19:03'!
unsubscribeFromBrowsers
	self browsers do: [ :browser |
		browser announcer unsubscribe: self ].
	self browsers: nil.! !

Object subclass: #CSExamplePerson
	instanceVariableNames: 'firstname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExamplePerson methodsFor: 'accessing' stamp: 'bs 1/21/2009 15:10'!
firstname
	^ firstname! !

!CSExamplePerson methodsFor: 'accessing' stamp: 'bs 1/21/2009 15:10'!
firstname: anObject
	firstname := anObject! !

Object subclass: #CSExampleTrace
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExampleTrace class methodsFor: 'accessing' stamp: 'mp 2/11/2009 17:22'!
traceRegistry

	^ CSTraceRegistry current! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 13:46'!
complexMethodCalls

	^ self loop + self incrementCounter + self squareCounter + self conditional! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 13:34'!
conditional

	^ self counter = 2
		ifTrue: [self squareCounter]
		ifFalse: [self incrementCounter]! !

!CSExampleTrace methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:43'!
counter
	"Answer the value of counter"

	^ counter! !

!CSExampleTrace methodsFor: 'accessing' stamp: 'mp 2/9/2009 13:51'!
counter: anObject
	"Set the value of counter"

	counter := anObject! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 11:45'!
doNothing! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 11:46'!
incrementCounter

	self counter: self counter + 1.
	^ self counter! !

!CSExampleTrace methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 18:08'!
initialize
	
	self counter: 0.
	self addDependent: self.! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 16:14'!
loop

	3 timesRepeat: [self incrementCounter].
	self squareCounter.
	^ self counter! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 18:09'!
observerCounter

	self incrementCounter.
	self changed.
	self incrementCounter.
	^ self counter! !

!CSExampleTrace methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 10:25'!
reset

	self initialize.! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 13:30'!
squareCounter

	self counter: self counter squared.
	^ self counter! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/13/2009 11:29'!
throwError

	[self error: 'Error'] ifError: [self incrementCounter].
	^ self counter

	! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 18:10'!
update: anObject

	self incrementCounter.! !

CSExampleTrace subclass: #CSSubExampleTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSSubExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 17:50'!
incrementCounter
	
	super incrementCounter.
	self counter: self counter + 1.
	^ self counter! !

Object subclass: #CSRegisteredTrace
	instanceVariableNames: 'identifier timestamp startEntries returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSRegisteredTrace class methodsFor: 'as yet unclassified' stamp: 'mp 2/10/2009 10:57'!
with: anIdentifier

	^ self new
		identifier: anIdentifier! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSRegisteredTrace methodsFor: 'initialize-release' stamp: 'mp 2/10/2009 10:57'!
initialize
	
	self 
		timestamp: DateAndTime now;
		startEntries: OrderedCollection new.! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/7/2009 16:38'!
returnValue
	"Answer the value of returnValue"

	^ returnValue! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/7/2009 16:38'!
returnValue: anObject
	"Set the value of returnValue"

	returnValue := anObject! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/6/2009 15:16'!
startEntries
	"Answer the value of startEntries"

	^ startEntries! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/6/2009 15:16'!
startEntries: anObject
	"Set the value of startEntries"

	startEntries := anObject! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
timestamp
	"Answer the value of timestamp"

	^ timestamp! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
timestamp: anObject
	"Set the value of timestamp"

	timestamp := anObject! !

Object subclass: #CSStepper
	instanceVariableNames: 'blockToExecute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
executeInNextStep: aBlock
	blockToExecute := aBlock.
	ActiveWorld startStepping: self at: Time millisecondClockValue selector: #step arguments: nil stepTime: nil.! !

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:02'!
shouldGetStepsFrom: aWorld
	^ActiveWorld == aWorld! !

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
step
	blockToExecute value.
	ActiveWorld stopStepping: self selector: #step.! !

Object subclass: #CSTestStatistic
	instanceVariableNames: 'maxTraceDepth minTraceDepth numCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSTestStatistic class methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 17:27'!
generateStatistics
	" 'all: 1149; coveredMethods: 634; directlyCoveredMethods: 174'"
	"  'all: 403; coveredMethods: 330; directlyCoveredMethods: 134'"
	"seaside 'all: 2478; coveredMethods: 534; directlyCoveredMethods: 123'"
	| classes methods coveredMethods directlyCoveredMethods loc |
	classes := CSTraceChooser allClasses reject: [:c | c inheritsFrom: TestCase].

	methods := Set new.
	classes do: [:c | methods addAll: c methodDict values].

	coveredMethods := methods select: [:m | m hasCoveringTestMethods].
	directlyCoveredMethods := (coveredMethods select: [:m | (m coveringTestMethods select: [:tm | (tm statisticsForCoveredMethod: m) minTraceDepth == 1]) size > 0 ]).
	
	loc := (classes collect: [:c | c linesOfCode ]) sum.

	^ 'all: ', methods size asString, '; coveredMethods: ', coveredMethods size asString, '; directlyCoveredMethods: ', directlyCoveredMethods size asString, '; loc: ', loc asString.! !

!CSTestStatistic methodsFor: 'initialize-release' stamp: 'bs 4/30/2009 16:01'!
addCallInDepth: aNumber
	(self numCalls = 0) 
		ifTrue: [
			self numCalls: 1.
			self minTraceDepth: aNumber.
			self maxTraceDepth: aNumber]
		ifFalse: [
			self numCalls: self numCalls + 1.
	
			(self minTraceDepth > aNumber) 
				ifTrue: [self minTraceDepth: aNumber].
	
			(self maxTraceDepth < aNumber) 
				ifTrue: [self maxTraceDepth: aNumber].
			].! !

!CSTestStatistic methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 11:24'!
asString
	^ maxTraceDepth asString, ' ', minTraceDepth asString, ' ', numCalls asString! !

!CSTestStatistic methodsFor: 'initialize-release' stamp: 'bs 4/30/2009 15:59'!
initialize
	maxTraceDepth := 0.
	minTraceDepth := 0.
	numCalls := 0.! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'mab 4/9/2009 12:53'!
maxTraceDepth
	^ maxTraceDepth! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 4/30/2009 10:39'!
maxTraceDepth: anObject
	maxTraceDepth := anObject! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 4/30/2009 10:36'!
minTraceDepth
	^ minTraceDepth! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 4/30/2009 10:40'!
minTraceDepth: anObject
	minTraceDepth := anObject! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'mab 4/9/2009 12:52'!
numCalls
	^ numCalls! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'mab 4/9/2009 12:52'!
numCalls: anInteger
	numCalls := anInteger! !

Object subclass: #CSTraceChooser
	instanceVariableNames: 'list listSelections'
	classVariableNames: 'Packages'
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:41'!
allClasses
	| set |
	set := Set new.
	self packages do: [ :packageName |
		set addAll: (PackageInfo named: packageName) classes ].
	^ set! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 19:11'!
build
	^ ToolBuilder build: self new! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 19:07'!
initialize
	"CSTraceChooser initialize"
	self registerInToolsFlap! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/3/2009 15:31'!
open
	^ ToolBuilder open: self new! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 18:52'!
packages
	^ Packages ifNil: [ Packages := Set new ]! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 19:12'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTraceChooser build 'Test Traces' 'Choose your packages for test tracing.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 18:08'!
buildWith: builder
	| windowSpec listSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'Test Trace Chooser'.
	windowSpec children: OrderedCollection new.
	listSpec := builder pluggableMultiSelectionListSpec new.
	listSpec 
		model: self;
		list: #list;
		getSelectionList: #listSelectionAt:;
		setSelectionList: #listSelectionAt:put:;
		frame: (0@0corner: 1@1).
	windowSpec children add: listSpec.

	^builder build: windowSpec! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 18:15'!
list
	^ list ifNil: [ list := (PackageOrganizer default packages collect: [ :packageInfo | packageInfo packageName ]) sort ]! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 18:07'!
listSelectionAt: index
	^ self listSelections at: index! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 18:54'!
listSelectionAt: index put: value
	(value and: [ (self listSelections at: index) not ]) ifTrue: [ "enable a package"
		self class packages add: (self list at: index) ].
	(value not and: [ self listSelections at: index ]) ifTrue: [ "disable a package"
		self class packages remove: (self list at: index) ].
	^ self listSelections at: index put: value! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 18:56'!
listSelections
	listSelections ifNil: [
		self list ifNotNil: [
			listSelections := Array new: self list size withAll: false.
			self list doWithIndex: [ :each :index |
				(self class packages includes: each) ifTrue: [
					listSelections at: index put: true ]]]].
	^ listSelections! !

Object subclass: #CSTraceEntry
	instanceVariableNames: 'methodClass methodSelector depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

CSTraceEntry subclass: #CSTraceCallEntry
	instanceVariableNames: 'receiver arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!CSTraceCallEntry methodsFor: 'iterating' stamp: 'mp 2/8/2009 12:18'!
getNextMethodPropertiesFor: anIdentifier

	^ (self methodClass methodDict at: self methodSelector) 
		properties at: anIdentifier! !

!CSTraceCallEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isCall

	^ true! !

!CSTraceCallEntry methodsFor: 'iterating' stamp: 'mp 2/9/2009 15:55'!
iterateNextMethodTrace: anIdentifier	withNextCallBlock: aCallBlock andReturnBlock: aReturnBlock
	
	(self getNextMethodPropertiesFor: anIdentifier)	
		do: [:each | 
			each
				predecessor: self
				ifNextCall: aCallBlock
				ifReturn: aReturnBlock]! !

!CSTraceCallEntry methodsFor: 'testing' stamp: 'mp 2/10/2009 10:48'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock
	
	(self depth size = (aCallEntry depth size + 1) and: [self depth beginsWith: aCallEntry depth])
		ifTrue: [aCallBlock value: self].! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 18:21'!
depth
	"Answer the value of depth"

	^ depth! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 18:21'!
depth: anObject
	"Set the value of depth"

	depth := anObject! !

!CSTraceEntry methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 13:01'!
initialize

	self depth: OrderedCollection new.! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isCall
	
	^ false! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isReturn

	^ false! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodClass
	"Answer the value of methodClass"

	^ methodClass! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodClass: anObject
	"Set the value of methodClass"

	methodClass := anObject! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodSelector
	"Answer the value of methodSelector"

	^ methodSelector! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodSelector: anObject
	"Set the value of methodSelector"

	methodSelector := anObject! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/8/2009 12:42'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock

	self subclassResponsibility.! !

CSTraceEntry subclass: #CSTraceReturnEntry
	instanceVariableNames: 'returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceReturnEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isReturn

	^ true! !

!CSTraceReturnEntry methodsFor: 'testing' stamp: 'mp 2/9/2009 15:55'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock

	self depth = aCallEntry depth
		ifTrue: [aReturnBlock value: self].! !

!CSTraceReturnEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:54'!
returnValue
	"Answer the value of returnValue"

	^ returnValue! !

!CSTraceReturnEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:54'!
returnValue: anObject
	"Set the value of returnValue"

	returnValue := anObject! !

Object subclass: #CSTraceRegistry
	instanceVariableNames: 'traces'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceRegistry class methodsFor: 'queries' stamp: 'mp 2/13/2009 11:24'!
cleanAllAnnotations

	CSTraceRegistry current traces keys do: [:key | self cleanAnnotationsFor: key].
	CSTraceRegistry current initialize.
	Smalltalk garbageCollect.! !

!CSTraceRegistry class methodsFor: 'queries' stamp: 'mp 2/13/2009 11:25'!
cleanAnnotationsFor: anIdentifier

	Smalltalk do: [:each | 
		[each methodDict 
			do: [:method | [method properties removeKey: anIdentifier] ifError: []].
		each class methodDict 
			do: [:method | [method properties removeKey: anIdentifier] ifError: []]]
		ifError: []].
	[CSTraceRegistry current traces removeKey: anIdentifier] ifError: [].! !

!CSTraceRegistry class methodsFor: 'instance creation' stamp: 'mp 2/5/2009 10:14'!
current

	UniqueInstance ifNil: [UniqueInstance := self basicNew initialize].
	^ UniqueInstance! !

!CSTraceRegistry class methodsFor: 'instance creation' stamp: 'mp 2/5/2009 10:12'!
new

	self error: 'Use current to get an instance of Class ' , self name.! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/10/2009 10:56'!
addNewTrace: anIdentifier

	self traces 
		at: anIdentifier ifPresent: [:each | self error: 'Trace key already exist.'];
		at: anIdentifier put: (CSRegisteredTrace with: anIdentifier).
! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/7/2009 16:39'!
at: anIdentifier putReturnValue: anObject

	(self traces at: anIdentifier) returnValue: anObject.! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/6/2009 15:18'!
at: anIdentifier putStartEntry: aTraceEntry

	(self traces at: anIdentifier) startEntries addLast: aTraceEntry.! !

!CSTraceRegistry methodsFor: 'initialize-release' stamp: 'mp 2/5/2009 10:14'!
initialize

	self traces: IdentityDictionary new.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 13:05'!
printCall: aCallEntry forTrace: anIdentifier on: aStream

	self printCallEntry: aCallEntry on: aStream.	
	aCallEntry 
		iterateNextMethodTrace: anIdentifier
		withNextCallBlock: [:call | 
			self printCall: call forTrace: anIdentifier on: aStream] 
		andReturnBlock: [:return | 
			self printReturnEntry: return on: aStream].! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:56'!
printCallEntry: aCallEntry on: aStream
			
	aStream cr.
	aCallEntry depth size timesRepeat: [aStream space].
	aStream	
		nextPutAll: aCallEntry methodClass asString;
		nextPutAll: '>>#';
		nextPutAll: aCallEntry methodSelector asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 13:05'!
printReturnEntry: aReturnEntry on: aStream

	aStream cr.
	aReturnEntry depth size timesRepeat: [aStream space].
	aStream
		nextPut: $^;	
		nextPutAll: aReturnEntry returnValue asString.

	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:52'!
printTrace: anIdentifier
		
	self printTrace: anIdentifier on: Transcript.
	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 12:01'!
printTrace: anIdentifier on: aStream
		
	self 
		printTraceIdentifier: anIdentifier on: aStream;
		printTraceStartEntries: anIdentifier on: aStream;
		printTraceResult: anIdentifier on: aStream.
	aStream flush.
	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:53'!
printTraceIdentifier: anIdentifier on: aStream

	aStream 
		cr;
		nextPut: $#;
		nextPutAll: anIdentifier asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 18:40'!
printTraceResult: anIdentifier on: aStream

	aStream 
		cr;
		nextPut: $^; 
		nextPutAll: (self traces at: anIdentifier) returnValue returnValue asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:55'!
printTraceStartEntries: anIdentifier on: aStream
	
	(self traces at: anIdentifier) startEntries do: [:each | 
		each isCall 
			ifTrue: [self printCall: each forTrace: anIdentifier on: aStream]
			ifFalse: [self error: 'Should not be possible. Trace is corrupted.']].! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 14:14'!
removeCall: aCallEntry forTrace: anIdentifier

	aCallEntry
		iterateNextMethodTrace: anIdentifier
		withNextCallBlock: [:call | 
			self removeCall: call forTrace: anIdentifier] 
		andReturnBlock: [:return | 
			((aCallEntry getNextMethodPropertiesFor: anIdentifier) last == return)
				ifTrue: [self removeData: aCallEntry fromTrace: anIdentifier]].	! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 14:16'!
removeData: aCallEntry fromTrace: anIdentifier

	(aCallEntry methodClass methodDict at: aCallEntry methodSelector) 
		properties removeKey: anIdentifier.! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 15:24'!
removeTrace: anIdentifier

	(self traces at: anIdentifier) startEntries do: [:each | 
		each isCall 
			ifTrue: [self removeCall: each forTrace: anIdentifier]
			ifFalse: [self error: 'Should not be possible. Trace is corrupted.']].
	self traces removeKey: anIdentifier.! !

!CSTraceRegistry methodsFor: 'accessing' stamp: 'mp 2/5/2009 10:14'!
traces
	"Answer the value of traces"

	^ traces! !

!CSTraceRegistry methodsFor: 'accessing' stamp: 'mp 2/5/2009 10:14'!
traces: anObject
	"Set the value of traces"

	traces := anObject! !

Object subclass: #CSTracer
	instanceVariableNames: 'identifier traceBlock depth currentDepth printFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTracer class methodsFor: 'initialization' stamp: 'mp 2/10/2009 12:40'!
identifier: aSymbol
	
	^ self new
		identifier: aSymbol! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:32'!
addCallFrom: aCurrentContext to: aPrevContext

	| entry |
	entry := self getCallEntry: aCurrentContext.
	aPrevContext == self traceBlock
		ifTrue: [self registry 
					at: self identifier 
					putStartEntry: entry]
		ifFalse: [self addEntry: entry to: aPrevContext].	! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:33'!
addEntry: entry to: aPrevContext

	| entries |
	entries := aPrevContext method properties 
				at: self identifier 
				ifAbsent: [OrderedCollection new].
	aPrevContext method properties 
		at: self identifier 
		put: (entries addLast: entry; yourself).! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/13/2009 13:39'!
addReturnFrom: aCurrentContext to: aPrevContext

	| entry |
	entry := self getReturnEntry: aCurrentContext.
	self addEntry: entry to: aPrevContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 17:41'!
categoriesFromReceiver: anObject

	| receiverClass |
	receiverClass := anObject class.
	receiverClass isMeta
		ifTrue: [receiverClass := anObject].
	^ receiverClass category! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 14:07'!
currentDepth
	"Answer the value of currentDepth"

	^ currentDepth! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 14:07'!
currentDepth: anObject
	"Set the value of currentDepth"

	currentDepth := anObject! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 10:06'!
depth
	"Answer the value of depth"

	^ depth! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 10:06'!
depth: anObject
	"Set the value of depth"

	depth := anObject! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:13'!
getCallEntry: aContext
							
	^ CSTraceCallEntry new
		depth: self depth veryDeepCopy;
		methodClass: aContext methodClass;
		methodSelector: aContext selector;
		"receiver: aContext receiver printString;"
		yourself! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/13/2009 18:16'!
getReturnEntry: aContext

	^ CSTraceReturnEntry new
		depth: self depth veryDeepCopy;
		returnValue: aContext top veryDeepCopy;
		methodClass: aContext methodClass;
		methodSelector: aContext selector;
		yourself! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:58'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:58'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSTracer methodsFor: 'private-depth' stamp: 'mp 2/6/2009 14:16'!
increaseDepth
		
	| entry |
	entry := self depth at: self currentDepth ifAbsent: nil.
	entry
		ifNil: [self depth at: self currentDepth ifAbsentPut: 1]
		ifNotNil: [self depth at: self currentDepth put: entry + 1].! !

!CSTracer methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 14:43'!
initialize
	
	self 
		identifier: DateAndTime now asString asSymbol;
		depth: OrderedCollection new;
		printFlag: false.! !

!CSTracer methodsFor: 'private-printing' stamp: 'mp 2/11/2009 14:44'!
printCallFrom: aContext

	self printFlag 
		ifTrue:[
			Transcript cr.
			self currentDepth timesRepeat: [Transcript space].
			Transcript 
				nextPutAll: aContext receiver printString;
				space; 
				nextPutAll: aContext selector; 
				space; 
				nextPutAll: self depth asString; 
				flush].! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/11/2009 14:43'!
printFlag
	"Answer the value of printFlag"

	^ printFlag! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/11/2009 14:43'!
printFlag: anObject
	"Set the value of printFlag"

	printFlag := anObject! !

!CSTracer methodsFor: 'private-printing' stamp: 'mp 2/11/2009 14:45'!
printReturnFrom: aContext

	self printFlag 
		ifTrue:[
			Transcript cr.
			self currentDepth timesRepeat: [Transcript space].
			Transcript 
				space; 
				nextPut: $^;
				nextPutAll: aContext top printString;
				space; 
				nextPutAll: self depth asString;
				flush].! !

!CSTracer methodsFor: 'private-depth' stamp: 'mp 2/6/2009 14:15'!
reduceDepth

	self depth size = (self currentDepth + 2)
		ifTrue: [self depth removeLast.].! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/10/2009 10:56'!
registerTrace

	self registry addNewTrace: self identifier.! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:09'!
registry
	
	^ CSTraceRegistry current! !

!CSTracer methodsFor: 'tracing' stamp: 'mp 2/11/2009 14:49'!
trace: aBlock

	| previousContext result |
	self 
		registerTrace;
		traceBlock: aBlock.
	previousContext := self traceBlock.
	result := thisContext sender
		runSimulated: self traceBlock
		contextAtEachStep:
			[:currentContext |
			"Sensor anyButtonPressed ifTrue: [^ nil]."
			currentContext == previousContext
				ifFalse:
					[previousContext := self traceWith: currentContext and: previousContext]].
		self registry 
			at: self identifier 
			putReturnValue: (CSTraceReturnEntry new
								returnValue: result).
		^ result! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:28'!
traceBlock
	"Answer the value of traceBlock"

	^ traceBlock! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:28'!
traceBlock: anObject
	"Set the value of traceBlock"

	traceBlock := anObject! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 18:12'!
traceMethodCallWith: aCurrentContext and: aPreviousContext
	
	self 
		increaseDepth;
		addCallFrom: aCurrentContext to: aPreviousContext;
		printCallFrom: aCurrentContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 18:12'!
traceReturnWith: aCurrentContext and: aPreviousContext
	
	self 
		reduceDepth;
		addReturnFrom: aCurrentContext to: aPreviousContext;
		printReturnFrom: aCurrentContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/10/2009 10:48'!
traceWith: aCurrentContext and: aPreviousContext

	self currentDepth: (aCurrentContext depthBelow: self traceBlock).
	aPreviousContext sender
		ifNil: [self traceReturnWith: aCurrentContext and: aPreviousContext]
		ifNotNil: [self traceMethodCallWith: aCurrentContext and: aPreviousContext].
	^ aCurrentContext! !

!Object methodsFor: '*codesight' stamp: 'bs 4/28/2009 18:20'!
debugAndUninstallBreakpointBefore
	(Debugger context: thisContext)
		debug: 'Debugger' executeBefore: [:debugger | 
			debugger down.
			BreakpointManager unInstall: debugger selectedContext method.
			debugger restartAfterMethodChanged.].
	Processor activeProcess suspend.! !

CsComposition subclass: #CSBrowserAspect
	instanceVariableNames: 'coveringTestsModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSBrowserAspect class methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 18:58'!
for: aCoveringTestsModel
	^ self new coveringTestsModel: aCoveringTestsModel! !

!CSBrowserAspect methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2009 18:09'!
adviceSubscribeForChangingSelections
	^ CsBeforeAfterVariation
		qualifier: (CsVariationQualifier attributes: { #receiverClassSpecific. })
		pointcut: [{ 	CsJoinPointDescriptor targetClass: OBBrowser targetSelector: #initialize }]
		afterBlock: [ :receiver :arguments :aspect :client :return |
			receiver announcer observe: OBSelectionChanged send: #browserChangedSelection: to: self coveringTestsModel ]! !

!CSBrowserAspect methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 18:57'!
coveringTestsModel
	^ coveringTestsModel! !

!CSBrowserAspect methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2009 18:53'!
coveringTestsModel: anObject
	coveringTestsModel := anObject! !

CsComposition subclass: #CSTestTraceAspect
	instanceVariableNames: 'classes packageName coveredMethods runningTestMethod traceDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSTestTraceAspect class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 16:32'!
for: aPackageName
	^ self new classes: (PackageInfo named: aPackageName) classes; packageName: aPackageName! !

!CSTestTraceAspect class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 15:19'!
forClasses: aCollection
	^ self new classes: aCollection! !

!CSTestTraceAspect methodsFor: 'advice' stamp: 'bs 4/30/2009 14:48'!
adviceTrace
	^ CsAroundVariation
		qualifier: (CsVariationQualifier attributes: { #receiverClassSpecific })
		pointcut: [ self classes
			collect: [ :each |  CsMatchAllJoinPointDescriptor targetClass: each ]]
		aroundBlock: [ :receiver :arguments :aspect :client :clientMethod | 
			|return|
			"Transcript show: clientMethod methodClass name, '>>#', clientMethod selector; cr."
			self incrementTraceDepth.
			self runningTestMethod called: clientMethod inDepth: self traceDepth.
			return := clientMethod valueWithReceiver: receiver arguments: arguments.
			self decrementTraceDepth.
			return ]! !

!CSTestTraceAspect methodsFor: 'accessing' stamp: 'mab 4/2/2009 15:18'!
classes
	^ classes! !

!CSTestTraceAspect methodsFor: 'accessing' stamp: 'mab 4/2/2009 15:18'!
classes: aCollection
	classes := aCollection! !

!CSTestTraceAspect methodsFor: 'trace depth' stamp: 'bs 4/30/2009 11:32'!
decrementTraceDepth
	self traceDepth: self traceDepth - 1! !

!CSTestTraceAspect methodsFor: 'trace depth' stamp: 'bs 4/30/2009 11:32'!
incrementTraceDepth
	self traceDepth: self traceDepth + 1! !

!CSTestTraceAspect methodsFor: 'accessing' stamp: 'mab 4/2/2009 16:32'!
packageName
	^ packageName! !

!CSTestTraceAspect methodsFor: 'accessing' stamp: 'mab 4/2/2009 16:32'!
packageName: aString
	packageName := aString! !

!CSTestTraceAspect methodsFor: 'trace depth' stamp: 'bs 4/30/2009 09:58'!
resetTraceDepth
	traceDepth := 0! !

!CSTestTraceAspect methodsFor: 'as yet unclassified' stamp: 'bs 4/24/2009 14:51'!
runningTestMethod
	^ runningTestMethod
	! !

!CSTestTraceAspect methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 11:36'!
testMethodGoingToRun: aCompiledMethod
	self resetTraceDepth.
	runningTestMethod := aCompiledMethod
	! !

!CSTestTraceAspect methodsFor: 'trace depth' stamp: 'bs 4/30/2009 11:30'!
traceDepth
	^ traceDepth ifNil: [traceDepth := 0]! !

!CSTestTraceAspect methodsFor: 'trace depth' stamp: 'bs 4/30/2009 11:31'!
traceDepth: aNumber
	traceDepth := aNumber! !

!OBClassNode methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:47'!
icon

	(theClass methodDict values anySatisfy: [:aMethod | aMethod hasCoveringTestMethods])
		ifTrue: [^ #csAccept]
		ifFalse: [^ super icon].! !

!Debugger methodsFor: '*codesight' stamp: 'bs 4/16/2009 12:06'!
debug: label executeBefore: aBlock
	"Open a full DebuggerView."
	Smalltalk isMorphic
		ifTrue:
			[self openFullMorphicLabel: label.
			 CSStepper new executeInNextStep: [aBlock value: self].
			 errorWasInUIProcess := Project spawnNewProcessIfThisIsUI: interruptedProcess.
			 ^self].
! !

!Debugger methodsFor: '*codesight' stamp: 'bs 4/16/2009 11:16'!
restartAfterMethodChanged 
	"The retrieved information has changed and its source must now be  
	updated. In this case, the retrieved information is the method of the  
	selected context."
	| selector classOfMethod category h ctxt |
	
	h := self selectedContext finalBlockHome.
	self resetContext: h.
	classOfMethod := self selectedClass.
	category := self selectedMessageCategoryName.
	selector := self selectedMessageName.
	
	contents := classOfMethod sourceCodeAt: selector.
	ctxt := interruptedProcess popTo: self selectedContext.
	interruptedProcess suspendedContext privRefreshWith: (classOfMethod compiledMethodAt: selector).
	"interruptedProcess
		restartTopWith: (classOfMethod compiledMethodAt: selector)."
	contextVariablesInspector object: nil.
	theMethodNode := Preferences browseWithPrettyPrint
		ifTrue: [ctxt methodNodeFormattedAndDecorated: Preferences colorWhenPrettyPrinting]
		ifFalse: [ctxt methodNode].
	sourceMap := theMethodNode sourceMap.
	tempNames := theMethodNode tempNames.
		
	self resetContext: ctxt.
	self changed.
	^ true! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 5/4/2009 21:53'!
compiledMethod
	^ theClass compiledMethodAt: self selector! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 5/4/2009 21:54'!
coveringTestMethods

	| testMethodNodes theMethod statistics node |
	testMethodNodes := OrderedCollection new.
	(theClass includesSelector: selector) ifTrue: [
		theMethod := self compiledMethod.
		theMethod coveringTestMethods do: [:testMethod | 
				statistics := testMethod statisticsForCoveredMethod: theMethod.
				node := OBCoveringTestCaseNode on: testMethod 
								statistic: statistics coveredMethodNode: self.
				testMethodNodes add: node
			]
		].
	
	^ testMethodNodes.! !

!OBMethodNode methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:41'!
icon

	(theClass includesSelector: selector) ifTrue: [
		(theClass compiledMethodAt: selector) hasCoveringTestMethods
			ifTrue: [^ #csAccept]].
	
	^ super icon.! !

OBClassAwareNode subclass: #OBCoveringTestCaseNode
	instanceVariableNames: 'coveredMethodNode testMethod statistics definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!OBCoveringTestCaseNode class methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2009 21:50'!
on: testMethod statistic: statistics coveredMethodNode: aCoveredMethodNode
	^ self new 
		testMethod: testMethod;
		statistics: statistics;
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 21:54'!
coveredMethod
	^ coveredMethodNode compiledMethod! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 21:49'!
coveredMethodNode
	^ coveredMethodNode! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 22:00'!
coveredMethodNode: anObject
	coveredMethodNode := anObject.
	definition := coveredMethodNode definition.! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 22:01'!
definition
	^ definition! !

!OBCoveringTestCaseNode methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 09:52'!
name
	^ statistics asString, ' ', testMethod methodClass name, '>>#', testMethod selector! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 21:21'!
statistics
	^ statistics! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 21:21'!
statistics: anObject
	statistics := anObject! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod
	^ testMethod! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod: anObject
	testMethod := anObject! !

OBNode subclass: #CSCallNode
	instanceVariableNames: 'call identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 17:20'!
call
	"Answer the value of call"

	^ call! !

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 17:20'!
call: anObject
	"Set the value of call"

	call := anObject! !

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:09'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:09'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSCallNode methodsFor: 'public' stamp: 'mp 2/8/2009 18:15'!
name

	^ self call methodClass asString, '>>#', self call methodSelector asString! !

!CSCallNode methodsFor: 'public' stamp: 'mp 2/8/2009 18:28'!
nextCalls

	| nodes |
	nodes := OrderedCollection new.
	self call
		iterateNextMethodTrace: self identifier
		withNextCallBlock: [:callEntry | nodes add: (CSCallNode new identifier: self identifier; call: callEntry)]
		andReturnBlock: [:returnEntry | nodes add: (CSReturnNode new return: returnEntry)].
	^ nodes! !

!CSCallNode methodsFor: 'public' stamp: 'mp 2/8/2009 18:44'!
text

	^ (self call methodClass methodDict at: self call methodSelector) getSource! !

CSCallNode subclass: #CSReturnNode
	instanceVariableNames: 'return'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSReturnNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:30'!
name

	^ self return returnValue asString! !

!CSReturnNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:29'!
nextCalls
	^ Array new! !

!CSReturnNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:29'!
return
	"Answer the value of return"

	^ return! !

!CSReturnNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:29'!
return: anObject
	"Set the value of return"

	return := anObject! !

!CSReturnNode methodsFor: 'as yet unclassified' stamp: 'mp 2/15/2009 12:41'!
text

	self return explore.
	^ 'Return value'.! !

OBNode subclass: #CSTraceStartNode
	instanceVariableNames: 'identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSTraceStartNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:05'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSTraceStartNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:05'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSTraceStartNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:06'!
name

	^ self identifier asString! !

!CSTraceStartNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:33'!
nextCalls
	
	| nodes |
	self identifier ifNil: [^ Array new].
	nodes := (CSTraceRegistry current traces at: self identifier) startEntries 
		collect: [:each | CSCallNode new 
						identifier: self identifier;
						call: each].
	nodes add: (CSReturnNode new identifier: self identifier; return: (CSTraceRegistry current traces at: self identifier) returnValue).
	^ nodes! !

!CSTraceStartNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 17:31'!
text

	^ 'abc'! !

!CSTraceStartNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:11'!
traces

	self identifier ifNil: [
		^ CSTraceRegistry current traces keys collect: [:each | CSTraceStartNode new identifier: each]].
	^ Array new.! !

!CsMethodWrapper methodsFor: '*codesight' stamp: 'mab 4/7/2009 19:19'!
compiledMethod
	^ self unwrappedMethod! !

!MenuIcons class methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:40'!
csAcceptIcon

	^ Icons
			at: #'csAccept'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csAcceptIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:39'!
csAcceptIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKfSURBVDjLpZPrS1NhHMf9O3bO
dmwDCWREIYKEUHsVJBI7mg3FvCxL09290jZj2EyLMnJexkgpLbPUanNOberU5taUMnHZUULM
velCtWF0sW/n7MVMEiN64AsPD8/n83uucQDi/id/DBT4Dolypw/qsz0pTMbj/WHpiDgsdSUy
UmeiPt2+V7SrIM+bSss8ySGdR4abQQv6lrui6VxsRonrGCS9VEjSQ9E7CtiqdOZ4UuTqnBHO
1X7YXl6Daa4yGq7vWO1D40wVDtj4kWQbn94myPGkCDPdSesczE2sCZShwl8CzcwZ6NiUs6n2
nYX99T1cnKqA2EKui6+TwphA5k4yqMayopU5mANV3lNQTBdCMVUA9VQh3GuDMHiVcLCS3J4j
SLhCGmKCjBEx0xlshjXYhApfMZRP5CyYD+UkG08+xt+4wLVQZA1tzxthm2tEfD3JxARH7Qkb
D1ZuozaggdZbxK5kAIsf5qGaKMTY2lAU/rH5HW3PLsEwUYy+YCcERmIjJpDcpzb6l7th9KtQ
69fi09ePUej9l7cx2DJbD7UrG3r3afQHOyCo+V3QQzE35pvQvnAZukk5zL5qRL59jsKbPzdh
eXoBZc4saFhBS6AO7V4zqCpiawuptwQG+UAa7Ct3UT0hh9p9EnXT5Vh6t4C22QaUDh6HwnEC
OmcO7K+6kW49DKqS2DrEZCtfuI+9GrNHg4fMHVSO5kE7nAPVkAxKBxcOzsajpS4Yh4ohUPPW
KTUh3PaQEptIOr6BiJjcZXCwktaAGfrRIpwblqOV3YKdhfXOIvBLeREWpnd8ynsaSJoyESFp
hwTtfjN6X1jRO2+FxWtCWksqBApeiFIR9K6fiTpPiigDoadqCEag5YUFKl6Yrciw0VOlhOiv
v/Ff8wtn0KzlebrUYwAAAABJRU5ErkJggg=='! !

!OBMethodCategoryNode methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:47'!
icon

	| methodSelectors categoryMethods |
	methodSelectors := (name = ClassOrganizer allCategory)
		ifTrue: [theClass organization allMethodSelectors]
		ifFalse: [theClass organization listAtCategoryNamed: name].
	categoryMethods := methodSelectors collect: [:aSelector | theClass compiledMethodAt: aSelector].
	(categoryMethods anySatisfy: [:aMethod | aMethod hasCoveringTestMethods])
		ifTrue: [^ #csAccept]
		ifFalse: [^ super icon].! !

OBPackageBrowser subclass: #CSBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 23:32'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
     | metaGraph |
     metaGraph := CSMetagraphBuilder
		               on: root class: classSel comment: commentSel metaclass: metaclassSel.
	metaGraph classMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	metaGraph metaclassMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	"metaGraph methodMetaNode doubleClickCommandClass: OBCmdSelectMethodCategory."
	^metaGraph execute ! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 20:52'!
defaultMetaNode
     | env smartGroup package cats classes builder |
	env := OBMetaNode named: 'Environment'.
	package := OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfPackage:.
	cats := OBMetaNode named: 'Cats'.
	cats
	      displaySelector: #nameWithoutPrefix;	
	      ancestrySelector: #isDescendantOfClassCat:.	
	(package childAt: #classCategories put: cats) navigateTree.
	
	self buildMetagraphOn: package.
	"self buildMetagraphOn: cats."
     (package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | cats addEdge: edge].
	package filters do: [:filter | cats addFilter: filter].

	classes := OBMetaNode named: 'Classes'.
	classes
		displaySelector: #indentedName;
		ancestrySelector: #isDescendantOfClass:.
	builder := CSMetagraphBuilder
		         on: classes 
	              class: #packagesForClassClass 
	              comment: #packagesForClassComment 
	              metaclass: #packagesForClassMetaclass.
	builder execute.
	builder classMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder metaclassMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder classCommentMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.							
	classes removeFilter: OBQueryingClassSortFilter new.
	
     smartGroup := OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	(package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | smartGroup addEdge: edge].
	smartGroup addFilter: OBModalFilter new;
		          addFilter: OBClassSortFilter new.
	
     env
		childAt: #packages
			labeled: 'pkgs'
			put: package;
		childAt: #classesHierarchically
			labeled: 'hier.'
			put: classes;				
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 23:12'!
paneCount
	^ 5! !

!CSBrowser methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2009 21:43'!
selectionChanged: announcement
	
	| node testMethod testClass testSelector testSuite |	
	node := announcement node.
	(node isNil not and: [ node isKindOf: OBCoveringTestCaseNode]) ifTrue: [
		testMethod := node testMethod.
		testClass := testMethod methodClass.
		testSelector := testMethod selector.
		testSuite := testClass suiteWithSelectorsMatching: testSelector.
		[
		BreakpointManager installSelfRemovingBreakpointInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector).
		[ testSuite run ] ensure: [ 
			BreakpointManager unInstallInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector). ].
		] forkAt: Processor activePriority.].! !

!CSBrowser methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2009 20:48'!
subscribe
	super subscribe.
	self announcer
		observe: OBSelectionChanged send: #selectionChanged: to: self.! !
CSTestRunner initialize!
CSCoveringTests initialize!
CSTraceChooser initialize!
